"""
not enougth time to make a "real" level format, so
they will be stored as pygame classes
"""

from lib2d.tilemap import BigMap, OneTileMap, View, ThreadedView, TMXMap, TileMapRenderer
from lib2d.renderer import Camera
from lib2d.npc import NPC
from lib2d.rpg import Hero, ActorGroup
from lib2d.dialog import ChoiceDialog
from worldstate import WorldState
from lib2d import param, gfx, sfx
from lib2d.statedriver import driver as sd
import lib2d.sheetloader

from pygame import Surface, draw

from math import ceil
from random import randint
import os.path

music = False

class VillageMap(WorldState):
    def activate(self):
        WorldState.activate(self)


        # HACK
        if not music:
            global music
            sfx.music("relent.ogg", loops=-1)
            music = True 

        self.actors = ActorGroup()

        #the_map = os.path.join(param.resource_path, "maps", "village/")
        #tilemap = BigMap(the_map)

        path = os.path.join(param.resource_path, "maps", "village.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((342, 208))
        self.hero.avatar.play("walk")
        self.actors.add(self.hero)
        self.camera.center(self.hero.position)
        tilemap.redraw()

        # boring npc's
        npc = lib2d.sheetloader.load_actor("serf0", NPC)
        npc.short_name = "Aquafina"
        npc.greeting = "I just LOVE bottled water, don't you?"
        npc.dialog = ChoiceDialog
        npc.d_arg = [npc.greeting, None, npc.short_name]
        npc.move_to((260,32))
        npc.face("south")
        self.actors.add(npc)

        npc = lib2d.sheetloader.load_actor("warrior0", NPC)
        npc.short_name = "Evian"
        npc.greeting = "Such great weather to go swimming!"
        npc.move_to((336,64))
        npc.face("south")
        self.actors.add(npc)

        npc = lib2d.sheetloader.load_actor("mayor", NPC)
        npc.short_name = "Dasani"
        npc.greeting = "Looks like rain."
        npc.move_to((200,352))
        npc.face("south")
        self.actors.add(npc)

        npc = lib2d.sheetloader.load_actor("ninja1", NPC)
        npc.short_name = "Glaceau"
        npc.greeting = "I am just SO thirsty."
        npc.move_to((200,256))
        npc.face("south")
        self.actors.add(npc)


        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.warps = {
            (12,13): (HallMap, (5,4)),
            (15,16): (HallMap, (9,8)),
            (19,22): (Building0Map, (6,4)),
            (15,22): (Building1Map, (6,4)),
            (11,22): (Building2Map, (6,4)),
            (6,11): (Building3Map, (6,4)),
            (20,11): (Building4Map, (6,4)),
            (27,16): (Building5Map, (6,4)),
            (10,4): (Building6Map, (6,4)),
            (23,4): (Building7Map, (6,4))
        }

class HallMap(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "hall.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((144, 160))
        self.hero.avatar.play("walk")
        self.actors.add(self.hero)

        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))
            
        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (15,17)),
            (9,11): (VillageMap, (15,17))
        }

class Building0Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)

        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))
        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (19,22))
        }

class Building1Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (15,22))
        }

class Building2Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (11,22))
        }


class Building3Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (6,11))
        }


class Building4Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (20,11))
        }


class Building5Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (27,16))
        }

class Building6Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (10,4))
        }


class Building7Map(WorldState):
    def activate(self):
        WorldState.activate(self)

        self.actors = ActorGroup()

        path = os.path.join(param.resource_path, "maps", "building0.tmx")
        tmxmap = TMXMap(path) # my renderer
        self.tmxloader = tmxmap.tmx # the loader
        tilemap = TileMapRenderer(tmxmap, sd.get_size())
        self.camera = Camera(self.actors, tilemap, ((0,0),sd.get_size()))

        # hero
        self.hero = lib2d.sheetloader.load_actor("hero", Hero)
        self.hero.move_to((45, 45))
        self.hero.avatar.play("walk")
        self.hero.face("north")
        self.actors.add(self.hero)
        if self.player_pos != None:
            self.hero.move_to((self.player_pos[0] * 16, self.player_pos[1] * 16))

        self.camera.center(self.hero.position)
        tilemap.redraw()

        self.warps = {
            (6,6): (VillageMap, (23,4))
        }
