from lib2d.gamestate import GameState
from lib2d.vec import Vec2d
from lib2d.tilemap import BigMap, OneTileMap, View, ThreadedView, TMXMap, TileMapRenderer
from lib2d.renderer import Camera
from lib2d.npc import NPC
from lib2d.rpg import Hero, ActorGroup
from lib2d.dialog import ChoiceDialog
from lib2d.statedriver import driver as sd
from lib2d.buttons import *
from lib2d import param, gfx, sfx
import lib2d.sheetloader

from pygame import Surface, draw

from math import ceil
from random import randint
import os.path

# HACK, Hack, hack, its all a hack

class WorldState(GameState):
    """
    This state is where the player will move the hero
    around the map interacting with other players,
    objects, etc.
    """

    def __init__(self, the_map=None, start=None):
        GameState.__init__(self)
        self.player_pos = start
        self.state = 0
        self.counter = 0

        # used to detect overlapping actors
        self.collisions = []

    def deactivate(self):
        GameState.deactivate(self)
        #sfx.fadeout_music()

    def draw(self, surface):
        self.camera.center(self.hero.position)
        self.camera.draw(surface)
 
        # wipe fadein
        if self.state == 0:
            surface.lock()
            for y in range(0, 240, 2):
                x = randint(-10, 10) + (self.counter * 20)
                draw.line(surface, (0,0,0), (0,y), (320-x, y), 2)
            surface.unlock()

            self.counter += 1

            if self.counter >= 20:
                self.state = 1
                self.counter = 0

    def update(self, time):
        if self.state < 1: return

        # update the actors
        self.actors.update(time)
        self.camera.update(time)

        # collision detection is probably only good for less than 100
        # objects or so, not really sure
        # handling collisions.  now thats what i call FUN.

        # check for stale collisions between actors
        self.collisions = [ (c[0], c[1]) for \
            c in self.collisions \
            if c[0].get_rect().colliderect(c[1].get_rect()) == True ]

        # WWWEEEEEEEE!!!!
        for actor in self.actors.actors:
            l = self.actors.actors[:]
            l.remove(actor)
            i = actor.get_rect().collidelist([ a.get_rect() for a in l ])
            if (i >= 0):
                actor.stop()
                if ((actor, l[i]) not in self.collisions):
                    l[i].OnPush(actor)
                    self.collisions.append((actor, l[i]))
                    self.collisions.append((l[i], actor))

        # prevent actors from moving into blocked areas
        # last hours of pyweek, this is an epic HACK
        control_layer = self.camera.tilemap.tilemap.layers[-1]

        left, top = self.hero.get_rect().topleft
        tx = left / 16.0
        ty = top / 16.0

        def check_tile(x, y):
            try:
                warp = self.warps[(x,y)]
            except:
                pass
            else:
                sd.replace(warp[0](start=warp[1]))
            try:
                if control_layer.content2D[x][y] != 0: self.hero.stop()
            except:
                pass       

        check_tile(int(tx), int(ty)) 
        check_tile(int(tx), int(ceil(ty)))
        check_tile(int(ceil(tx)), int(ty))
        check_tile(int(ceil(tx)), int(ceil(ty)))

    def handle_commandlist(self, cmdlist):
        if self.state < 1: return

        for cls, cmd, arg in cmdlist:
            if cmd == P1_UP:
                self.hero.v.y = -arg * self.hero.move_speed
                if self.hero.v != (0,0): self.hero.avatar.play("walk")
            elif cmd == P1_DOWN:
                self.hero.v.y = arg * self.hero.move_speed
                if self.hero.v != (0,0): self.hero.avatar.play("walk")
            elif cmd == P1_LEFT:
                self.hero.v.x = -arg * self.hero.move_speed
                if self.hero.v != (0,0): self.hero.avatar.play("walk")
            elif cmd == P1_RIGHT:
                self.hero.v.x = arg * self.hero.move_speed
                if self.hero.v != (0,0): self.hero.avatar.play("walk")
            elif (cmd == P1_ACTION1) and arg:
                self.hero.attack()
