"""
Copyright 2010, 2011  Leif Theden


This file is part of lib2d.

lib2d is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

lib2d is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with lib2d.  If not, see <http://www.gnu.org/licenses/>.
"""

class GameState(object):
    def __init__(self):
        # this is a once only thing
        self.activated = False

    # when given focus for first time
    def activate(self):
        self.activated = True

    # when focus is given again
    def reactivate(self):
        pass

    # when losing focus
    def deactivate(self):
        pass

    def draw(self, surface):
        pass

    def handle_event(self, event):
        pass

    # time is ms since last call
    def update(self, time):
        pass

    # handle a game command (usually player input)
    def handle_command(self, command):
        pass

    # handle a bunch of commands
    def handle_commandlist(self, cmdlist):
        pass
