"""
Copyright 2010, 2011  Leif Theden


This file is part of lib2d.

lib2d is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

lib2d is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with lib2d.  If not, see <http://www.gnu.org/licenses/>.
"""

from rpg import Actor
from dialog import TextDialog, ChoiceDialog 
from statedriver import driver as sd
from random import uniform

class NPC(Actor):
    def __init__(self):
        Actor.__init__(self)
        self.greeting = "how r u?"
        self.dialog = None
        self.d_arg = []
        self.d_kwarg = {}

    def update(self, time):
        Actor.update(self, time)

    def OnPush(self, other):
        """
        When the player pushes this NPC.

        Will not be called when the NPC pushes into the player.
        """

        if self.dialog == None:
            dialog = TextDialog(self.greeting, title=self.short_name)
            sd.start(dialog)
        else:
            dialog = self.dialog(*self.d_arg, **self.d_kwarg)
            sd.start(dialog)
        
    def OnActivate(self, other):
        """
        When the player uses the Action button on or facing this object.

        """

        dialog = TextDialog(self.greeting, self.short_name)
        sd.start(dialog)
