#!/usr/bin/env python

from lib2d import param
import pygame
import os

from lib2d.statedriver import driver as sd
from lib2d import gfx, config

from lib.titlescreen import TitleScreen



pygame.init()
pygame.font.init()

gfx.init()
gfx.set_screen((640, 480), 2, "scale")

param.resource_path = "resources"
param.default_font  = "dpcomic.ttf"


class Game(object):
    def __init__(self):
        self.config = {}

    def load_config(self, location):
        pass

    def get_config(self):
        return self.config

    def get_screen(self):
        return gfx.screen

    def start(self):
        sd.set_parent(self)
        sd.start(TitleScreen())
        try:
            sd.run()
        except:
            pygame.quit()
            raise

if __name__ == "__main__":
    Game().start()


